From f082b53118e7a174b8c9a79964abaeef4a34fa29 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Dominik=20Sch=C3=BCrmann?= <dominik@dominikschuermann.de>
Date: Sun, 23 Mar 2014 02:17:39 +0100
Subject: Extend provider for new api tables

---
 .../keychain/provider/KeychainContract.java        |  64 ++++++++-
 .../keychain/provider/KeychainDatabase.java        |   8 +-
 .../keychain/provider/KeychainProvider.java        | 149 ++++++++++++++++++---
 .../keychain/provider/ProviderHelper.java          |  42 ++++--
 4 files changed, 222 insertions(+), 41 deletions(-)

(limited to 'OpenPGP-Keychain/src/main/java')

diff --git a/OpenPGP-Keychain/src/main/java/org/sufficientlysecure/keychain/provider/KeychainContract.java b/OpenPGP-Keychain/src/main/java/org/sufficientlysecure/keychain/provider/KeychainContract.java
index de51cebbb..aa4c1f131 100644
--- a/OpenPGP-Keychain/src/main/java/org/sufficientlysecure/keychain/provider/KeychainContract.java
+++ b/OpenPGP-Keychain/src/main/java/org/sufficientlysecure/keychain/provider/KeychainContract.java
@@ -63,7 +63,7 @@ public class KeychainContract {
         String ENCRYPTION_ALGORITHM = "encryption_algorithm";
         String HASH_ALORITHM = "hash_algorithm";
         String COMPRESSION = "compression";
-        String PACKAGE_NAME = "package_name"; // foreign key to api_apps.package_name
+        String PACKAGE_NAME_FK = "package_name"; // foreign key to api_apps.package_name
     }
 
     public static final class KeyTypes {
@@ -90,7 +90,10 @@ public class KeychainContract {
     public static final String PATH_USER_IDS = "user_ids";
     public static final String PATH_KEYS = "keys";
 
-    public static final String BASE_API_APPS = "api_apps";
+    public static final String BASE_API = "api";
+    public static final String PATH_APPS = "apps";
+    public static final String PATH_ACCOUNTS = "accounts";
+
     public static final String PATH_BY_PACKAGE_NAME = "package_name";
 
     public static class KeyRings implements KeyRingsColumns, BaseColumns {
@@ -254,19 +257,70 @@ public class KeychainContract {
         }
     }
 
+    /**
+     * Join over ApiApps with ApiAppsAccounts
+     */
+    public static class Api implements ApiAppsColumns, ApiAppsAccountsColumns, BaseColumns {
+        public static final Uri CONTENT_URI = BASE_CONTENT_URI_INTERNAL.buildUpon()
+                .appendPath(BASE_API).build();
+
+        /**
+         * Use if multiple items get returned
+         */
+        public static final String CONTENT_TYPE = "vnd.android.cursor.dir/vnd.thialfihar.apg.apis";
+
+        /**
+         * Use if a single item is returned
+         */
+        public static final String CONTENT_ITEM_TYPE = "vnd.android.cursor.item/vnd.thialfihar.apg.api";
+
+        public static Uri buildIdUri(String rowId) {
+            return CONTENT_URI.buildUpon().appendPath(rowId).build();
+        }
+
+        public static Uri buildByPackageNameUri(String packageName) {
+            return CONTENT_URI.buildUpon().appendPath(PATH_BY_PACKAGE_NAME).appendPath(packageName)
+                    .build();
+        }
+    }
+
     public static class ApiApps implements ApiAppsColumns, BaseColumns {
         public static final Uri CONTENT_URI = BASE_CONTENT_URI_INTERNAL.buildUpon()
-                .appendPath(BASE_API_APPS).build();
+                .appendPath(BASE_API).appendPath(PATH_APPS).build();
+
+        /**
+         * Use if multiple items get returned
+         */
+        public static final String CONTENT_TYPE = "vnd.android.cursor.dir/vnd.thialfihar.apg.api.app";
+
+        /**
+         * Use if a single item is returned
+         */
+        public static final String CONTENT_ITEM_TYPE = "vnd.android.cursor.item/vnd.thialfihar.apg.api.apps";
+
+        public static Uri buildIdUri(String rowId) {
+            return CONTENT_URI.buildUpon().appendPath(rowId).build();
+        }
+
+        public static Uri buildByPackageNameUri(String packageName) {
+            return CONTENT_URI.buildUpon().appendPath(PATH_BY_PACKAGE_NAME).appendPath(packageName)
+                    .build();
+        }
+    }
+
+    public static class ApiAccounts implements ApiAppsAccountsColumns, BaseColumns {
+        public static final Uri CONTENT_URI = BASE_CONTENT_URI_INTERNAL.buildUpon()
+                .appendPath(BASE_API).appendPath(PATH_ACCOUNTS).build();
 
         /**
          * Use if multiple items get returned
          */
-        public static final String CONTENT_TYPE = "vnd.android.cursor.dir/vnd.thialfihar.apg.api_apps";
+        public static final String CONTENT_TYPE = "vnd.android.cursor.dir/vnd.thialfihar.apg.api.acoounts";
 
         /**
          * Use if a single item is returned
          */
-        public static final String CONTENT_ITEM_TYPE = "vnd.android.cursor.item/vnd.thialfihar.apg.api_apps";
+        public static final String CONTENT_ITEM_TYPE = "vnd.android.cursor.item/vnd.thialfihar.apg.api.account";
 
         public static Uri buildIdUri(String rowId) {
             return CONTENT_URI.buildUpon().appendPath(rowId).build();
diff --git a/OpenPGP-Keychain/src/main/java/org/sufficientlysecure/keychain/provider/KeychainDatabase.java b/OpenPGP-Keychain/src/main/java/org/sufficientlysecure/keychain/provider/KeychainDatabase.java
index f7c9fe79d..e56fa2f8f 100644
--- a/OpenPGP-Keychain/src/main/java/org/sufficientlysecure/keychain/provider/KeychainDatabase.java
+++ b/OpenPGP-Keychain/src/main/java/org/sufficientlysecure/keychain/provider/KeychainDatabase.java
@@ -38,7 +38,7 @@ public class KeychainDatabase extends SQLiteOpenHelper {
         String KEYS = "keys";
         String USER_IDS = "user_ids";
         String API_APPS = "api_apps";
-        String API_APPS_ACCOUNTS = "api_apps_accounts";
+        String API_ACCOUNTS = "api_accounts";
     }
 
     private static final String CREATE_KEY_RINGS = "CREATE TABLE IF NOT EXISTS " + Tables.KEY_RINGS
@@ -80,14 +80,14 @@ public class KeychainDatabase extends SQLiteOpenHelper {
             + ApiAppsColumns.PACKAGE_NAME + " TEXT UNIQUE, "
             + ApiAppsColumns.PACKAGE_SIGNATURE + " BLOB)";
 
-    private static final String CREATE_API_APPS_ACCOUNTS = "CREATE TABLE IF NOT EXISTS " + Tables.API_APPS_ACCOUNTS
+    private static final String CREATE_API_APPS_ACCOUNTS = "CREATE TABLE IF NOT EXISTS " + Tables.API_ACCOUNTS
             + " (" + BaseColumns._ID + " INTEGER PRIMARY KEY AUTOINCREMENT, "
             + ApiAppsAccountsColumns.KEY_ID + " INT64, "
             + ApiAppsAccountsColumns.ENCRYPTION_ALGORITHM + " INTEGER, "
             + ApiAppsAccountsColumns.HASH_ALORITHM + " INTEGER, "
             + ApiAppsAccountsColumns.COMPRESSION + " INTEGER"
-            + ApiAppsAccountsColumns.PACKAGE_NAME + " TEXT NOT NULL, FOREIGN KEY("
-            + ApiAppsAccountsColumns.PACKAGE_NAME + ") REFERENCES " + Tables.API_APPS + "("
+            + ApiAppsAccountsColumns.PACKAGE_NAME_FK + " TEXT NOT NULL, FOREIGN KEY("
+            + ApiAppsAccountsColumns.PACKAGE_NAME_FK + ") REFERENCES " + Tables.API_APPS + "("
             + ApiAppsColumns.PACKAGE_NAME + ") ON DELETE CASCADE)";
 
     KeychainDatabase(Context context) {
diff --git a/OpenPGP-Keychain/src/main/java/org/sufficientlysecure/keychain/provider/KeychainProvider.java b/OpenPGP-Keychain/src/main/java/org/sufficientlysecure/keychain/provider/KeychainProvider.java
index 746449f7e..a094b13de 100644
--- a/OpenPGP-Keychain/src/main/java/org/sufficientlysecure/keychain/provider/KeychainProvider.java
+++ b/OpenPGP-Keychain/src/main/java/org/sufficientlysecure/keychain/provider/KeychainProvider.java
@@ -1,5 +1,5 @@
 /*
- * Copyright (C) 2012-2013 Dominik Schürmann <dominik@dominikschuermann.de>
+ * Copyright (C) 2012-2014 Dominik Schürmann <dominik@dominikschuermann.de>
  * Copyright (C) 2010 Thialfihar <thi@thialfihar.org>
  *
  * Licensed under the Apache License, Version 2.0 (the "License");
@@ -28,8 +28,19 @@ import android.database.sqlite.SQLiteQueryBuilder;
 import android.net.Uri;
 import android.provider.BaseColumns;
 import android.text.TextUtils;
+
 import org.sufficientlysecure.keychain.Constants;
-import org.sufficientlysecure.keychain.provider.KeychainContract.*;
+import org.sufficientlysecure.keychain.provider.KeychainContract.Api;
+import org.sufficientlysecure.keychain.provider.KeychainContract.ApiAccounts;
+import org.sufficientlysecure.keychain.provider.KeychainContract.ApiApps;
+import org.sufficientlysecure.keychain.provider.KeychainContract.ApiAppsAccountsColumns;
+import org.sufficientlysecure.keychain.provider.KeychainContract.KeyRings;
+import org.sufficientlysecure.keychain.provider.KeychainContract.KeyRingsColumns;
+import org.sufficientlysecure.keychain.provider.KeychainContract.KeyTypes;
+import org.sufficientlysecure.keychain.provider.KeychainContract.Keys;
+import org.sufficientlysecure.keychain.provider.KeychainContract.KeysColumns;
+import org.sufficientlysecure.keychain.provider.KeychainContract.UserIds;
+import org.sufficientlysecure.keychain.provider.KeychainContract.UserIdsColumns;
 import org.sufficientlysecure.keychain.provider.KeychainDatabase.Tables;
 import org.sufficientlysecure.keychain.util.Log;
 
@@ -70,9 +81,15 @@ public class KeychainProvider extends ContentProvider {
     private static final int SECRET_KEY_RING_USER_ID = 221;
     private static final int SECRET_KEY_RING_USER_ID_BY_ROW_ID = 222;
 
-    private static final int API_APPS = 301;
-    private static final int API_APPS_BY_ROW_ID = 302;
-    private static final int API_APPS_BY_PACKAGE_NAME = 303;
+    private static final int API = 301;
+    private static final int API_BY_ROW_ID = 302;
+    private static final int API_BY_PACKAGE_NAME = 303;
+    private static final int API_APPS = 304;
+    private static final int API_APPS_BY_ROW_ID = 305;
+    private static final int API_APPS_BY_PACKAGE_NAME = 306;
+    private static final int API_ACCOUNTS = 307;
+    private static final int API_ACCOUNTS_BY_ROW_ID = 308;
+    private static final int API_ACCOUNTS_BY_PACKAGE_NAME = 309;
 
     private static final int UNIFIED_KEY_RING = 401;
 
@@ -230,11 +247,27 @@ public class KeychainProvider extends ContentProvider {
         /**
          * API apps
          */
-        matcher.addURI(authority, KeychainContract.BASE_API_APPS, API_APPS);
-        matcher.addURI(authority, KeychainContract.BASE_API_APPS + "/#", API_APPS_BY_ROW_ID);
-        matcher.addURI(authority, KeychainContract.BASE_API_APPS + "/"
+        matcher.addURI(authority, KeychainContract.BASE_API, API);
+        matcher.addURI(authority, KeychainContract.BASE_API + "/#", API_BY_ROW_ID);
+        matcher.addURI(authority, KeychainContract.BASE_API + "/"
+                + KeychainContract.PATH_BY_PACKAGE_NAME + "/*", API_BY_PACKAGE_NAME);
+
+        matcher.addURI(authority, KeychainContract.BASE_API + "/"
+                + KeychainContract.PATH_APPS, API_APPS);
+        matcher.addURI(authority, KeychainContract.BASE_API + "/"
+                + KeychainContract.PATH_APPS + "/#", API_APPS_BY_ROW_ID);
+        matcher.addURI(authority, KeychainContract.BASE_API + "/"
+                + KeychainContract.PATH_APPS + "/"
                 + KeychainContract.PATH_BY_PACKAGE_NAME + "/*", API_APPS_BY_PACKAGE_NAME);
 
+        matcher.addURI(authority, KeychainContract.BASE_API + "/"
+                + KeychainContract.PATH_ACCOUNTS, API_ACCOUNTS);
+        matcher.addURI(authority, KeychainContract.BASE_API + "/"
+                + KeychainContract.PATH_ACCOUNTS + "/#", API_ACCOUNTS_BY_ROW_ID);
+        matcher.addURI(authority, KeychainContract.BASE_API + "/"
+                + KeychainContract.PATH_ACCOUNTS + "/"
+                + KeychainContract.PATH_BY_PACKAGE_NAME + "/*", API_ACCOUNTS_BY_PACKAGE_NAME);
+
         /**
          * data stream
          *
@@ -299,6 +332,13 @@ public class KeychainProvider extends ContentProvider {
             case SECRET_KEY_RING_USER_ID_BY_ROW_ID:
                 return UserIds.CONTENT_ITEM_TYPE;
 
+            case API:
+                return Api.CONTENT_TYPE;
+
+            case API_BY_ROW_ID:
+            case API_BY_PACKAGE_NAME:
+                return Api.CONTENT_ITEM_TYPE;
+
             case API_APPS:
                 return ApiApps.CONTENT_TYPE;
 
@@ -306,6 +346,13 @@ public class KeychainProvider extends ContentProvider {
             case API_APPS_BY_PACKAGE_NAME:
                 return ApiApps.CONTENT_ITEM_TYPE;
 
+            case API_ACCOUNTS:
+                return ApiAccounts.CONTENT_TYPE;
+
+            case API_ACCOUNTS_BY_ROW_ID:
+            case API_ACCOUNTS_BY_PACKAGE_NAME:
+                return ApiAccounts.CONTENT_ITEM_TYPE;
+
             default:
                 throw new UnsupportedOperationException("Unknown uri: " + uri);
         }
@@ -506,7 +553,6 @@ public class KeychainProvider extends ContentProvider {
                 }
 
                 break;
-
             case PUBLIC_KEY_RING:
             case SECRET_KEY_RING:
                 qb = buildKeyRingQuery(qb, match);
@@ -516,7 +562,6 @@ public class KeychainProvider extends ContentProvider {
                 }
 
                 break;
-
             case PUBLIC_KEY_RING_BY_ROW_ID:
             case SECRET_KEY_RING_BY_ROW_ID:
                 qb = buildKeyRingQuery(qb, match);
@@ -529,7 +574,6 @@ public class KeychainProvider extends ContentProvider {
                 }
 
                 break;
-
             case PUBLIC_KEY_RING_BY_MASTER_KEY_ID:
             case SECRET_KEY_RING_BY_MASTER_KEY_ID:
                 qb = buildKeyRingQuery(qb, match);
@@ -542,7 +586,6 @@ public class KeychainProvider extends ContentProvider {
                 }
 
                 break;
-
             case SECRET_KEY_RING_BY_KEY_ID:
             case PUBLIC_KEY_RING_BY_KEY_ID:
                 qb = buildKeyRingQueryWithSpecificKey(qb, match);
@@ -555,7 +598,6 @@ public class KeychainProvider extends ContentProvider {
                 }
 
                 break;
-
             case SECRET_KEY_RING_BY_EMAILS:
             case PUBLIC_KEY_RING_BY_EMAILS:
                 qb = buildKeyRingQuery(qb, match);
@@ -585,7 +627,6 @@ public class KeychainProvider extends ContentProvider {
                 }
 
                 break;
-
             case SECRET_KEY_RING_BY_LIKE_EMAIL:
             case PUBLIC_KEY_RING_BY_LIKE_EMAIL:
                 qb = buildKeyRingQuery(qb, match);
@@ -601,7 +642,6 @@ public class KeychainProvider extends ContentProvider {
                         + "))");
 
                 break;
-
             case PUBLIC_KEY_RING_KEY:
             case SECRET_KEY_RING_KEY:
                 qb.setTables(Tables.KEYS);
@@ -614,7 +654,6 @@ public class KeychainProvider extends ContentProvider {
                 qb.setProjectionMap(getProjectionMapForKeys());
 
                 break;
-
             case PUBLIC_KEY_RING_KEY_BY_ROW_ID:
             case SECRET_KEY_RING_KEY_BY_ROW_ID:
                 qb.setTables(Tables.KEYS);
@@ -630,7 +669,6 @@ public class KeychainProvider extends ContentProvider {
                 qb.setProjectionMap(getProjectionMapForKeys());
 
                 break;
-
             case PUBLIC_KEY_RING_BY_MASTER_KEY_ID_USER_ID:
                 qb.setTables(Tables.USER_IDS + " INNER JOIN " + Tables.KEY_RINGS + " ON " + "("
                         + Tables.KEY_RINGS + "." + BaseColumns._ID + " = " + Tables.USER_IDS + "."
@@ -641,7 +679,6 @@ public class KeychainProvider extends ContentProvider {
                 qb.setProjectionMap(getProjectionMapForUserIds());
 
                 break;
-
             case PUBLIC_KEY_RING_USER_ID:
             case SECRET_KEY_RING_USER_ID:
                 qb.setTables(Tables.USER_IDS);
@@ -649,7 +686,6 @@ public class KeychainProvider extends ContentProvider {
                 qb.appendWhereEscapeString(uri.getPathSegments().get(2));
 
                 break;
-
             case PUBLIC_KEY_RING_USER_ID_BY_ROW_ID:
             case SECRET_KEY_RING_USER_ID_BY_ROW_ID:
                 qb.setTables(Tables.USER_IDS);
@@ -660,7 +696,28 @@ public class KeychainProvider extends ContentProvider {
                 qb.appendWhereEscapeString(uri.getLastPathSegment());
 
                 break;
+            case API:
+                qb.setTables(Tables.API_ACCOUNTS + " INNER JOIN " + Tables.API_APPS + " ON " + "("
+                        + Tables.API_APPS + "." + ApiApps.PACKAGE_NAME + " = " + Tables.API_ACCOUNTS + "."
+                        + ApiAccounts.PACKAGE_NAME_FK + " )");
+
+                break;
+            case API_BY_ROW_ID:
+                qb.setTables(Tables.API_ACCOUNTS + " INNER JOIN " + Tables.API_APPS + " ON " + "("
+                        + Tables.API_APPS + "." + ApiApps.PACKAGE_NAME + " = " + Tables.API_ACCOUNTS + "."
+                        + ApiAccounts.PACKAGE_NAME_FK + " )");
+                qb.appendWhere(Tables.API_APPS + "." + BaseColumns._ID + " = ");
+                qb.appendWhereEscapeString(uri.getLastPathSegment());
+
+                break;
+            case API_BY_PACKAGE_NAME:
+                qb.setTables(Tables.API_ACCOUNTS + " INNER JOIN " + Tables.API_APPS + " ON " + "("
+                        + Tables.API_APPS + "." + ApiApps.PACKAGE_NAME + " = " + Tables.API_ACCOUNTS + "."
+                        + ApiAccounts.PACKAGE_NAME_FK + " )");
+                qb.appendWhere(Tables.API_APPS + "." + ApiApps.PACKAGE_NAME + " = ");
+                qb.appendWhereEscapeString(uri.getLastPathSegment());
 
+                break;
             case API_APPS:
                 qb.setTables(Tables.API_APPS);
 
@@ -675,10 +732,26 @@ public class KeychainProvider extends ContentProvider {
             case API_APPS_BY_PACKAGE_NAME:
                 qb.setTables(Tables.API_APPS);
                 qb.appendWhere(ApiApps.PACKAGE_NAME + " = ");
-                qb.appendWhereEscapeString(uri.getPathSegments().get(2));
+                qb.appendWhereEscapeString(uri.getLastPathSegment());
+
+                break;
+            case API_ACCOUNTS:
+                qb.setTables(Tables.API_ACCOUNTS);
 
                 break;
+            case API_ACCOUNTS_BY_ROW_ID:
+                qb.setTables(Tables.API_ACCOUNTS);
 
+                qb.appendWhere(BaseColumns._ID + " = ");
+                qb.appendWhereEscapeString(uri.getLastPathSegment());
+
+                break;
+            case API_ACCOUNTS_BY_PACKAGE_NAME:
+                qb.setTables(Tables.API_ACCOUNTS);
+                qb.appendWhere(ApiAppsAccountsColumns.PACKAGE_NAME_FK + " = ");
+                qb.appendWhereEscapeString(uri.getLastPathSegment());
+
+                break;
             default:
                 throw new IllegalArgumentException("Unknown URI " + uri);
 
@@ -770,6 +843,11 @@ public class KeychainProvider extends ContentProvider {
                     rowId = db.insertOrThrow(Tables.API_APPS, null, values);
                     rowUri = ApiApps.buildIdUri(Long.toString(rowId));
 
+                    break;
+                case API_ACCOUNTS:
+                    rowId = db.insertOrThrow(Tables.API_ACCOUNTS, null, values);
+                    rowUri = ApiAccounts.buildIdUri(Long.toString(rowId));
+
                     break;
                 default:
                     throw new UnsupportedOperationException("Unknown uri: " + uri);
@@ -836,6 +914,14 @@ public class KeychainProvider extends ContentProvider {
                 count = db.delete(Tables.API_APPS, buildDefaultApiAppsSelection(uri, true, selection),
                         selectionArgs);
                 break;
+            case API_ACCOUNTS_BY_ROW_ID:
+                count = db.delete(Tables.API_ACCOUNTS, buildDefaultApiAccountsSelection(uri, false, selection),
+                        selectionArgs);
+                break;
+            case API_ACCOUNTS_BY_PACKAGE_NAME:
+                count = db.delete(Tables.API_ACCOUNTS, buildDefaultApiAccountsSelection(uri, true, selection),
+                        selectionArgs);
+                break;
             default:
                 throw new UnsupportedOperationException("Unknown uri: " + uri);
         }
@@ -906,6 +992,14 @@ public class KeychainProvider extends ContentProvider {
                     count = db.update(Tables.API_APPS, values,
                             buildDefaultApiAppsSelection(uri, true, selection), selectionArgs);
                     break;
+                case API_ACCOUNTS_BY_ROW_ID:
+                    count = db.update(Tables.API_ACCOUNTS, values,
+                            buildDefaultApiAccountsSelection(uri, false, selection), selectionArgs);
+                    break;
+                case API_ACCOUNTS_BY_PACKAGE_NAME:
+                    count = db.update(Tables.API_ACCOUNTS, values,
+                            buildDefaultApiAccountsSelection(uri, true, selection), selectionArgs);
+                    break;
                 default:
                     throw new UnsupportedOperationException("Unknown uri: " + uri);
             }
@@ -1018,6 +1112,21 @@ public class KeychainProvider extends ContentProvider {
         }
     }
 
+    private String buildDefaultApiAccountsSelection(Uri uri, boolean packageSelection, String selection) {
+        String lastPathSegment = uri.getLastPathSegment();
+
+        String andSelection = "";
+        if (!TextUtils.isEmpty(selection)) {
+            andSelection = " AND (" + selection + ")";
+        }
+
+        if (packageSelection) {
+            return ApiAccounts.PACKAGE_NAME_FK + "=" + lastPathSegment + andSelection;
+        } else {
+            return BaseColumns._ID + "=" + lastPathSegment + andSelection;
+        }
+    }
+
     // @Override
     // public ParcelFileDescriptor openFile(Uri uri, String mode) throws FileNotFoundException {
     // int match = mUriMatcher.match(uri);
